// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _WOKTools_BasicMapIterator_HeaderFile
#define _WOKTools_BasicMapIterator_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class WOKTools_BasicMap;


//! This  class  provides    basic   services  for the <br>
//! iterators  on Maps. The  iterators  are  inherited <br>
//! from this one. <br>
//! <br>
//! The  iterator   contains  an   array   of pointers <br>
//! (buckets). Each bucket is a  pointer  on a node. A <br>
//! node contains a pointer on the next node. <br>
//! <br>
//! This class  provides also basic  services for  the <br>
//! implementation of Maps. <br>
class WOKTools_BasicMapIterator  {
public:

  void* operator new(size_t,void* anAddress) 
  {
    return anAddress;
  }
  void* operator new(size_t size) 
  {
    return Standard::Allocate(size); 
  }
  void  operator delete(void *anAddress) 
  {
    if (anAddress) Standard::Free((Standard_Address&)anAddress); 
  }

  //! Resets the iterator to the first node. <br>
  Standard_EXPORT     void Reset() ;
  //! Returns True if there is a current  element in the <br>
//!          iterator. <br>
        Standard_Boolean More() const;
  //! Sets the  iterator   to the  next   node.  If  the <br>
//! iterator is empty it will not change. <br>
  Standard_EXPORT     void Next() ;





protected:

  //! Creates an empty iterator. <br>
  Standard_EXPORT   WOKTools_BasicMapIterator();
  //! Initialize on the first node in the buckets. <br>
  Standard_EXPORT   WOKTools_BasicMapIterator(const WOKTools_BasicMap& M);
  //! Initialize on the first node in the buckets. <br>
  Standard_EXPORT     void Initialize(const WOKTools_BasicMap& M) ;


Standard_Address myNode;


private:



Standard_Integer myNbBuckets;
Standard_Address myBuckets;
Standard_Integer myBucket;


};


#include <WOKTools_BasicMapIterator.lxx>



// other Inline functions and methods (like "C++: function call" methods)


#endif
